#include "CRM32Pro.h"
//#include "stdlib.h"

// ---Definiciones---
#define TITLE "Buscaminas 1.5 by Harko" //titulo de la ventana
#define RESOURCES "gfx.dpf" //paquete de imagenes
//#define MAXMINAS 71 //Maximo, a tope, 800
#define TILES_X 60  //Maximo tiles X 60 Minimo 10
#define TILES_Y 40  //Maximo tiles Y 40 Minimo 1
// Principianta 9x9 10
// Intermedio   16x16 40
// Experto      30x16 99

CRM32Pro_CTile *tile;
CRM32Pro_CFont *font;
int partida[TILES_X][TILES_Y];
int minas[TILES_X][TILES_Y];
int maxX=16;
int maxY=16;
int MAXMINAS=40; //Maximo maxX/maxY-1
int nminas=MAXMINAS;
int relojini=0;
int reloj=0;
int relojant=0, relojnow=0;
char text[10];
Uint8 empezar=0, jugar=0, pulsado=0;
int temp=0;

void InitPartida(){
  int x,y;
  //nminas=MAXMINAS;
  empezar=0;
  //Ponemos a cero las dos tablas
  for(x=0;x<maxX;x++){
    for(y=0;y<maxY;y++){
      partida[x][y]=1;
      minas[x][y]=0;
    }
  }
}

void DetectaTiles(int *cx, int *cy){
  // Basandose en la posicion del raton averigua en que tile esta
  *cx=(CRM32Pro.mouse_x-5)/16;
  *cy=(CRM32Pro.mouse_y-30)/16;
}

void MostrarMinas(int tx, int ty){
  int x,y;

  for(x=0;x<maxX;x++){
    for(y=0;y<maxY;y++){
      if(minas[x][y]==1){
        if(x==tx && y==ty){
          partida[x][y]=13;
        }else if(partida[x][y]!=11){
          partida[x][y]=12;
        }
      }else if(partida[x][y]==11){
        partida[x][y]=14;
      }
    }
  }
  jugar=0;
}

int CompruebaMinas(){
  int x=0,y=0;
  int vacio=0;
  for(x=0;x<maxX && vacio==0;x++){
    for(y=0;y<maxY && vacio==0;y++){
      if(minas[x][y]==0)
        vacio=1;
    }
  }
  return vacio;
}

void ModificaTile(int tx, int ty){
  int n=0;
  int x=0,y=0;
  if (partida[tx][ty]==1){
    if(minas[tx][ty]==1){
      MostrarMinas(tx,ty);
      //nminas--;
    }else{
      //n=Alrededor(tx,ty);
      n=0;
      for(x=tx-1;x<=tx+1;x++){
        for(y=ty-1;y<=ty+1;y++){
          if((x>=0 && x<maxX) && (y>=0 && y<maxY)){
            if(minas[x][y]==1){
              n++;
            }
          }
        }
      }
      partida[tx][ty]=n+2;
      minas[tx][ty]=n+2;
      if(n==0){
        for(x=tx-1;x<=tx+1;x++){
          for(y=ty-1;y<=ty+1;y++){
            if((x>=0 && x<maxX) && (y>=0 && y<maxY) && (x!=tx || y!=ty)){
              ModificaTile(x,y);
            }
          }
        }
      }
    }
  }
}

void InitMinas(){
  int x=0,y=0,cx=0,cy=0;
  int n=0;

  DetectaTiles(&cx,&cy);
  while(n<MAXMINAS){
    do{
      x=(int)CRM32Pro.Rand()/10000000;
      //x=rand();
    }while(x<0 || x>=maxX);
    do{
      y=CRM32Pro.Rand()/10000000;
      //y=rand();
    }while(y<0 || y>=maxY);
    if(minas[x][y]==0 && (x!=cx || y!=cy)){
      minas[x][y]=1;
      x++;
      n++;
    }
  }
  empezar=1;
}

void RenderGraphics(int n){
  int x,y;
  int tx=0,ty=0;

  SDL_FillRect(CRM32Pro.screen,NULL,SDL_MapRGB(CRM32Pro.screen->format,205,205,205));

  sprintf(text,"Minas: %d",nminas);
  font->PutString(CRM32Pro.screen,5,5,text);

  //font->PutString(CRM32Pro.screen,65,5,"F2=Nuevo juego");
  /*if((CRM32Pro.mouse_x>=5 && CRM32Pro.mouse_x<5+(16*15)) && (CRM32Pro.mouse_y>=30 && CRM32Pro.mouse_y<30+(16*14))){
    font->PutString(CRM32Pro.screen,70,5,"1");
  }else{
    font->PutString(CRM32Pro.screen,70,5,"0");
  }*/

  switch(CRM32Pro.mouse_buttons){
    case 1:
      if(pulsado==0 && jugar==1){
        if((CRM32Pro.mouse_x>=5 && CRM32Pro.mouse_x<5+(16*maxX)) && (CRM32Pro.mouse_y>=30 && CRM32Pro.mouse_y<30+(16*maxY))){
          if(empezar==0){
            InitMinas();
            relojini=1;
            reloj=0;
            relojant=ITimeSystem->GetTime();
          }
          DetectaTiles(&tx,&ty);
          ModificaTile(tx,ty);
          //Comprobamos si aun quedan sitios sin minas.
          if(CompruebaMinas()==0){
            jugar=2;
            for(x=0;x<maxX;x++){
              for(y=0;y<maxY;y++){
                if(minas[x][y]==1){
                  partida[x][y]=11;
                }
              }
            }
          }
        }
      }
      pulsado=1; break;

    case 4:
      if(pulsado==0 && jugar==1){
        if(CRM32Pro.mouse_buttons==4){
          DetectaTiles(&tx,&ty);
          if(partida[tx][ty]==1){
            partida[tx][ty]=11;
            nminas--;
          }else if(partida[tx][ty]==11){
            partida[tx][ty]=1;
            nminas++;
          }
        }
      }
      pulsado=1; break;
    case 0: pulsado=0;
  }

  if(jugar!=1){
    if(jugar==0){
      font->PutStringXCenter(CRM32Pro.screen,28+16*maxY,"Has perdido");
    }else{
      font->PutStringXCenter(CRM32Pro.screen,28+16*maxY,"Has ganado");
    }
    font->PutStringXCenter(CRM32Pro.screen,41+16*maxY,"F2=Nuevo juego");
    relojini=0;
  }else{
    font->PutStringXCenter(CRM32Pro.screen,35+16*maxY,"F2=Nuevo juego");
  }

  if(relojini==1){
    relojnow=ITimeSystem->GetTime();
    if(relojnow-1000>=relojant){
      reloj++;
      relojant=relojnow;
    }
  }
  sprintf(text,"%d",reloj);
  font->PutString(CRM32Pro.screen,maxX*16-20,5,text);

  // Dibujamos las tiles
  for(x=0;x<maxX;x++){
    for(y=0;y<maxY;y++){
      tile->SetPosition(5+x*16,30+y*16);
      tile->Draw(NULL,partida[x][y]);
    }
  }
}

// -------------FUNCION MAIN----------------
int main( int argc, char* args[] )
{
    // ---Variables---
  SDL_Event event;            //para recoger los eventos
  Uint8 done = 0;
  int x,y;

  // -Log system initialize-
  ILogSystem.Init("Buscaminas.log",LOG_FILE,LOG_NORMAL,TITLE);

  //Iniciamos CRM32Pro
  if(CRM32Pro.Init(SDL_INIT_VIDEO|SDL_INIT_TIMER) < 0){
    ILogSystem.Msg(LOG_NORMAL,"  [LOG] - Couldnt initialize CRM32Pro: %s\n",SDL_GetError());
    return 1;
  }

  //Configuracion deseada
  CRM32Pro.Config.Title = TITLE; //titulo de la ventana
  // Establecemos la resolucion
  CRM32Pro.Config.VideoWidth = 10+16*maxX;   // 10 + las tiles que hayan de ancho
  CRM32Pro.Config.VideoHeight = 60+16*maxY;  // por 60+ las tiles que hayan de alto
  CRM32Pro.Config.VideoBPP = 32;      //y una profunidad de bit de 32

  //Establecemos el modo de video
  if(!CRM32Pro.SetVideoMode()){
    CRM32Pro.Quit();
    return 1;
  }

  ITimeSystem->Init();
  ITimeSystem->SetRate(0,20);
  CRM32Pro.SetRenderCallback(RenderGraphics);

  //Cargamos los graficos
  font = new CRM32Pro_CFont;
  font->Load(RESOURCES,"fuente");
  tile = new CRM32Pro_CTile();
  if(tile->Load(RESOURCES,"tiles")==0){
    ILogSystem.Msg(LOG_NORMAL,"  [LOG] - Error al cargar tile: %s\n",SDL_GetError());
    return 1;
  }

  InitPartida();
  jugar=1;

  // Esperamos la pulsacin de una tecla para salir
  while(done == 0) {

    while ( CRM32Pro.Update(&event) ) {

      if ( event.type == SDL_KEYDOWN ){
        if(event.key.keysym.sym == SDLK_F9)
          SDL_SaveBMP(CRM32Pro.screen,"buscaminas.bmp");
        if(event.key.keysym.sym == SDLK_F2){
          InitPartida();
          relojini=0;
          reloj=0;
          if (jugar!=1){
            jugar=1;
          }
        }
        if(event.key.keysym.sym == SDLK_ESCAPE)
          done = 1;
      }
      if ( event.type == SDL_QUIT ){
        done=1;
      }
    }
  }

  //Liberamos las superficies
  delete tile;

  //Quit CRM32Pro
  CRM32Pro.Quit();

  return 0;
}

